program ExtTest;
type double = real;
type TRecord = record I: Integer; B: Boolean; R: Real; end;
type TRecord2 = record B1, B2: Boolean; end;
type TArray1 = array[1..2] of Char;
type TArray2 = array[1..200] of Integer;

const ExtDLL = 'ExtTest.dll';
function STD_MultiParam(a,b,c,d,e: Integer; f: double; g: String; h: TRecord; i:TRecord2): String; stdcall;   external ExtDLL;
function REG_MultiParam(a,b,c,d,e: Integer; f: double; g: String; h: TRecord; i:TRecord2): String; register;  external ExtDLL;
function PAS_MultiParam(a,b,c,d,e: Integer; f: double; g: String; h: TRecord; i:TRecord2): String; pascal;    external ExtDLL;
function CDECL_MultiParam(a,b,c,d,e: Integer; f: double; g: String; h: TRecord; i:TRecord2): String; cdecl;   external ExtDLL;
function SAFE_MultiParam(a,b,c,d,e: Integer; f: double; g: String; h: TRecord; i:TRecord2): String; safecall; external ExtDLL;
function SAFE_RetString(a: integer): String; safecall; external ExtDLL;

//procedure StrInsert(Source: String; var S: String; Index: Integer); external 'PSExternal.dll';
//////////////////////////////////////////////////////////////////
// STRING
//////////////////////////////////////////////////////////////////
procedure STD_Str_Val(S: String); stdcall;       external ExtDLL;
procedure STD_Str_Var(var S: String); stdcall;   external ExtDLL;
procedure CDECL_Str_Val(S: String); cdecl;       external ExtDLL;
procedure CDECL_Str_Var(var S: String); cdecl;   external ExtDLL;
procedure REG_Str_Val(S: String); register;      external ExtDLL;
procedure REG_Str_Var(var S: String); register;  external ExtDLL;
procedure PAS_Str_Val(S: String); pascal;        external ExtDLL;
procedure PAS_Str_Var(var S: String); pascal;    external ExtDLL;
procedure SAFE_Str_Val(S: String); safecall;     external ExtDLL;
procedure SAFE_Str_Var(var S: String); safecall; external ExtDLL;

//////////////////////////////////////////////////////////////////
// ENUM
//////////////////////////////////////////////////////////////////
type TEnum = (Red, Blue, Green);
procedure STD_Enum_Val(E: TEnum); stdcall;          external ExtDLL;
procedure STD_Enum_Var(var E: TEnum); stdcall;      external ExtDLL;
procedure CDECL_Enum_Val(E: TEnum); cdecl;          external ExtDLL;
procedure CDECL_Enum_Var(var E: TEnum); cdecl;      external ExtDLL;
procedure REG_Enum_Val(E: TEnum); register;         external ExtDLL;
procedure REG_Enum_Var(var E: TEnum); register;     external ExtDLL;
procedure SAFE_Enum_Val(E: TEnum); safecall;        external ExtDLL;
procedure SAFE_Enum_Var(var E: TEnum); safecall;    external ExtDLL;
procedure PAS_Enum_Val(E: TEnum); pascal;           external ExtDLL;
procedure PAS_Enum_Var(var E: TEnum); pascal;       external ExtDLL;

//////////////////////////////////////////////////////////////////
// RANGE
//////////////////////////////////////////////////////////////////
type TRange = 0..10;
procedure STD_Range_Val(R: TRange); stdcall;        external ExtDLL;
procedure STD_Range_Var(var R: TRange); stdcall;    external ExtDLL;
procedure REG_Range_Val(R: TRange); register;       external ExtDLL;
procedure REG_Range_Var(var R: TRange); register;   external ExtDLL;
procedure PAS_Range_Val(R: TRange); pascal;         external ExtDLL;
procedure PAS_Range_Var(var R: TRange); pascal;     external ExtDLL;
procedure CDECL_Range_Val(R: TRange); cdecl;        external ExtDLL;
procedure CDECL_Range_Var(var R: TRange); cdecl;    external ExtDLL;
procedure SAFE_Range_Val(R: TRange); safecall;      external ExtDLL;
procedure SAFE_Range_Var(var R: TRange); safecall;  external ExtDLL;


//////////////////////////////////////////////////////////////////
// RECORD
//////////////////////////////////////////////////////////////////
procedure STD_Record_Val(R: TRecord); stdcall;        external ExtDLL;
procedure STD_Record_Var(var R: TRecord); stdcall;    external ExtDLL;
procedure REG_Record_Val(R: TRecord); register;       external ExtDLL;
procedure REG_Record_Var(var R: TRecord); register;   external ExtDLL;
procedure PAS_Record_Val(R: TRecord); pascal;         external ExtDLL;
procedure PAS_Record_Var(var R: TRecord); pascal;     external ExtDLL;
procedure SAFE_Record_Val(R: TRecord); safecall;      external ExtDLL;
procedure SAFE_Record_Var(var R: TRecord); safecall;  external ExtDLL;
procedure CDECL_Record_Val(R: TRecord); cdecl;        external ExtDLL;
procedure CDECL_Record_Var(var R: TRecord); cdecl;    external ExtDLL;

/////////////////////////////////////////////////////
function STD_RetRec: TRecord; stdcall;        external ExtDLL;
function STD_RetRec2: TRecord2; stdcall;      external ExtDLL;
function REG_RetRec: TRecord; register;       external ExtDLL;
function REG_RetRec2: TRecord2; register;     external ExtDLL;
function PAS_RetRec: TRecord; pascal;         external ExtDLL;
function PAS_RetRec2: TRecord2; pascal;       external ExtDLL;
function SAFE_RetRec: TRecord; safecall;      external ExtDLL;
function SAFE_RetRec2: TRecord2; safecall;    external ExtDLL;
function CDECL_RetRec: TRecord; cdecl;        external ExtDLL;
function CDECL_RetRec2: TRecord2; cdecl;      external ExtDLL;

//////////////////////////////////////////////////////////////////

procedure STD_Array1_Val(A: TArray1); stdcall;         external ExtDLL;
procedure STD_Array1_Var(var A: TArray1); stdcall;     external ExtDLL;
procedure STD_Array2_Val(A: TArray2); stdcall;         external ExtDLL;
procedure STD_Array2_Var(var A: TArray2); stdcall;     external ExtDLL;
procedure REG_Array1_Val(A: TArray1); register;        external ExtDLL;
procedure REG_Array1_Var(var A: TArray1); register;    external ExtDLL;
procedure REG_Array2_Val(A: TArray2); register;        external ExtDLL;
procedure REG_Array2_Var(var A: TArray2); register;    external ExtDLL;
procedure SAFE_Array1_Val(A: TArray1); safecall;       external ExtDLL;
procedure SAFE_Array1_Var(var A: TArray1); safecall;   external ExtDLL;
procedure SAFE_Array2_Val(A: TArray2); safecall;       external ExtDLL;
procedure SAFE_Array2_Var(var A: TArray2); safecall;   external ExtDLL;
procedure CDECL_Array1_Val(A: TArray1); cdecl;         external ExtDLL;
procedure CDECL_Array1_Var(var A: TArray1); cdecl;     external ExtDLL;
procedure CDECL_Array2_Val(A: TArray2); cdecl;         external ExtDLL;
procedure CDECL_Array2_Var(var A: TArray2); cdecl;     external ExtDLL;
procedure PAS_Array1_Val(A: TArray1); pascal;          external ExtDLL;
procedure PAS_Array1_Var(var A: TArray1); pascal;      external ExtDLL;
procedure PAS_Array2_Val(A: TArray2); pascal;          external ExtDLL;
procedure PAS_Array2_Var(var A: TArray2); pascal;      external ExtDLL;

///////////////////////////////////////////////////////////
function STD_RetArr1: TArray1; stdcall;    external ExtDLL;
function STD_RetArr2: TArray2; stdcall;    external ExtDLL;
function REG_RetArr1: TArray1; register;   external ExtDLL;
function REG_RetArr2: TArray2; register;   external ExtDLL;
function SAFE_RetArr1: TArray1; safecall;  external ExtDLL;
function SAFE_RetArr2: TArray2; safecall;  external ExtDLL;
function CDECL_RetArr1: TArray1; cdecl;    external ExtDLL;
function CDECL_RetArr2: TArray2; cdecl;    external ExtDLL;
function PAS_RetArr1: TArray1; pascal;     external ExtDLL;
function PAS_RetArr2: TArray2; pascal;     external ExtDLL;


//////////////////////////////////////////////////////////////////
// more ARRAY
//////////////////////////////////////////////////////////////////
function STD_SumIArr(x,y,z: integer; A: array of integer): integer; stdcall;         external ExtDLL;
function STD_SumIArr2(x,y,z: integer; var A: array of integer): integer; stdcall;    external ExtDLL;
function REG_SumIArr(x,y,z: integer; A: array of integer): integer; register;        external ExtDLL;
function REG_SumIArr2(x,y,z: integer; var A: array of integer): integer; register;   external ExtDLL;
function PAS_SumIArr(x,y,z: integer; A: array of integer): integer; pascal;          external ExtDLL;
function PAS_SumIArr2(x,y,z: integer; var A: array of integer): integer; pascal;     external ExtDLL;
function SAFE_SumIArr(x,y,z: integer; A: array of integer): integer; safecall;       external ExtDLL;
function SAFE_SumIArr2(x,y,z: integer; var A: array of integer): integer; safecall;  external ExtDLL;
function CDECL_SumIArr(x,y,z: integer; A: array of integer): integer; cdecl;         external ExtDLL;
function CDECL_SumIArr2(x,y,z: integer; var A: array of integer): integer; cdecl;    external ExtDLL;

//////////////////////////////
function PAS_Sum3(X, Y, Z: Integer): Integer; pascal;      external ExtDLL;
function STD_Sum3(X, Y, Z: Integer): Integer; stdcall;     external ExtDLL;
function REG_Sum3(X, Y, Z: Integer): Integer; register;    external ExtDLL;
function SAFE_Sum3(X, Y, Z: Integer): Integer; safecall;   external ExtDLL;
function CDECL_Sum3(X, Y, Z: Integer): Integer; cdecl;     external ExtDLL;

//////////////////////////////
function STD_Variant(V1, V2: Variant; var V3: Variant): Variant; stdcall;   external ExtDLL;
function REG_Variant(V1, V2: Variant; var V3: Variant): Variant; register;  external ExtDLL;
function PAS_Variant(V1, V2: Variant; var V3: Variant): Variant; pascal;    external ExtDLL;
function SAFE_Variant(V1, V2: Variant; var V3: Variant): Variant; safecall; external ExtDLL;
function CDECL_Variant(V1, V2: Variant; var V3: Variant): Variant; cdecl;   external ExtDLL;

//////////////////////////////
function LocalTest: Real; begin Result := 2.718281828; end;
function CRLF: String; begin Result := Chr(13); Result := Result + Chr(10); end;
//////////////////////////////
//////////////////////////////

var I: integer;
    Enum: TEnum;
    Range: TRange;
    S: String;
    Rec: TRecord; Rec2: TRecord2;
    Arr1: TArray1; Arr2: TArray2;
    IArr: array of integer;
    V1, V2, V3: Variant;
    Count: Integer;
begin
  WriteLn(CRLF+'Starting dll + calling convention tests');

  // commands that generate problems (copies):
  //write('1: -');  {} writeln('-');
  //write('2: -');  {} writeln('-');
  //write('3: -');  {} writeln('-');
  // end of problematic commands

  // ................. Tests ...................................................
  // String test
  WriteLn(CRLF+'String test...');
  S := '123'; STD_Str_Val(S); STD_Str_Var(S); STD_Str_Val(S);       // 123 -> [123]
  S := '234'; REG_Str_Val(S); REG_Str_Var(S); REG_Str_Val(S);
  S := '345'; PAS_Str_Val(S); PAS_Str_Var(S); PAS_Str_Val(S);
  S := '456'; SAFE_Str_Val(S); SAFE_Str_Var(S); SAFE_Str_Val(S);
  S := '567'; CDECL_Str_Val(S); CDECL_Str_Var(S); CDECL_Str_Val(S);

  // Enum test
  WriteLn(CRLF+'Enum test...');
  Enum := Green;  STD_Enum_Val(Enum);   STD_Enum_Var(Enum);   STD_Enum_Val(Enum);
  Enum := Green;  SAFE_Enum_Val(Enum);  SAFE_Enum_Var(Enum);  SAFE_Enum_Val(Enum);
  Enum := Green;  CDECL_Enum_Val(Enum); CDECL_Enum_Var(Enum); CDECL_Enum_Val(Enum);
  Enum := Green;  REG_Enum_Val(Enum);   REG_Enum_Var(Enum);   REG_Enum_Val(Enum);
  Enum := Green;  PAS_Enum_Val(Enum);   PAS_Enum_Var(Enum);   PAS_Enum_Val(Enum);

  // Subrange test
  WriteLn(CRLF+'Subrange test...');
  Range := 5;     STD_Range_Val(Range); STD_Range_Var(Range); STD_Range_Val(Range);
  Range := 5;     SAFE_Range_Val(Range); SAFE_Range_Var(Range); SAFE_Range_Val(Range);
  Range := 5;     CDECL_Range_Val(Range); CDECL_Range_Var(Range); CDECL_Range_Val(Range);
  Range := 5;     REG_Range_Val(Range); REG_Range_Var(Range); REG_Range_Val(Range);
  Range := 5;     PAS_Range_Val(Range); PAS_Range_Var(Range); PAS_Range_Val(Range);

  // Record test
  WriteLn(CRLF+'Record test...');
  Rec.I := 5; Rec.B := true; Rec.R := 3.1415;
  STD_Record_Val(Rec);    STD_Record_Var(Rec);    STD_Record_Val(Rec);
  REG_Record_Val(Rec);    REG_Record_Var(Rec);    REG_Record_Val(Rec);
  PAS_Record_Val(Rec);    PAS_Record_Var(Rec);    PAS_Record_Val(Rec);
  CDECL_Record_Val(Rec);  CDECL_Record_Var(Rec);  CDECL_Record_Val(Rec);
  SAFE_Record_Val(Rec);   SAFE_Record_Var(Rec);   SAFE_Record_Val(Rec);
  STD_Sum3(7,8,9);

  // Array test
  WriteLn(CRLF+'Array test 1...');
  Arr1[1] := 'S'; Arr1[2] := 'K';  STD_Array1_Val(Arr1);   STD_Array1_Var(Arr1);   STD_Array1_Val(Arr1);
  Arr2[1] := 100; Arr2[2] := 200;  STD_Array2_Val(Arr2);   STD_Array2_Var(Arr2);   STD_Array2_Val(Arr2);
  Arr1[1] := 'S'; Arr1[2] := 'K';  REG_Array1_Val(Arr1);   REG_Array1_Var(Arr1);   REG_Array1_Val(Arr1);
  Arr2[1] := 100; Arr2[2] := 200;  REG_Array2_Val(Arr2);   REG_Array2_Var(Arr2);   REG_Array2_Val(Arr2);
  Arr1[1] := 'S'; Arr1[2] := 'K';  CDECL_Array1_Val(Arr1); CDECL_Array1_Var(Arr1); CDECL_Array1_Val(Arr1);
  Arr2[1] := 100; Arr2[2] := 200;  CDECL_Array2_Val(Arr2); CDECL_Array2_Var(Arr2); CDECL_Array2_Val(Arr2);
  Arr1[1] := 'S'; Arr1[2] := 'K';  SAFE_Array1_Val(Arr1);  SAFE_Array1_Var(Arr1);  SAFE_Array1_Val(Arr1);
  Arr2[1] := 100; Arr2[2] := 200;  SAFE_Array2_Val(Arr2);  SAFE_Array2_Var(Arr2);  SAFE_Array2_Val(Arr2);
  Arr1[1] := 'S'; Arr1[2] := 'K';  PAS_Array1_Val(Arr1);   PAS_Array1_Var(Arr1);   PAS_Array1_Val(Arr1);
  Arr2[1] := 100; Arr2[2] := 200;  PAS_Array2_Val(Arr2);   PAS_Array2_Var(Arr2);   PAS_Array2_Val(Arr2);

  // return record test
  WriteLn(CRLF+'Return-record test...');
  Rec := STD_RetRec;  writeln(Rec.I, '  ', Rec.R);       // should show 77  3.14
  Rec2 := STD_RetRec2;  writeln(Rec2.B1, '  ', Rec2.B2); // should show TRUE FALSE
  Rec := REG_RetRec;  writeln(Rec.I, '  ', Rec.R);       // should show 77  3.14
  Rec2 := REG_RetRec2;  writeln(Rec2.B1, '  ', Rec2.B2); // should show TRUE FALSE
  Rec := PAS_RetRec;  writeln(Rec.I, '  ', Rec.R);       // should show 77  3.14
  Rec2 := PAS_RetRec2;  writeln(Rec2.B1, '  ', Rec2.B2); // should show TRUE FALSE
  Rec := CDECL_RetRec;  writeln(Rec.I, '  ', Rec.R);       // should show 77  3.14
  Rec2 := CDECL_RetRec2;  writeln(Rec2.B1, '  ', Rec2.B2); // should show TRUE FALSE
  Rec := SAFE_RetRec;  writeln(Rec.I, '  ', Rec.R);       // should show 77  3.14
  Rec2 := SAFE_RetRec2;  writeln(Rec2.B1, '  ', Rec2.B2); // should show TRUE FALSE

  // return array test
  WriteLn(CRLF+'Return-array test...');
  Arr1 := STD_RetArr1; STD_Array1_Val(Arr1);  // should show 'X' 'Y'
  Arr2 := STD_RetArr2; STD_Array2_Val(Arr2);  // should show 111 222
  Arr1 := REG_RetArr1; STD_Array1_Val(Arr1);  // should show 'X' 'Y'
  Arr2 := REG_RetArr2; STD_Array2_Val(Arr2);  // should show 111 222
  Arr1 := PAS_RetArr1; STD_Array1_Val(Arr1);  // should show 'X' 'Y'
  Arr2 := PAS_RetArr2; STD_Array2_Val(Arr2);  // should show 111 222
  Arr1 := CDECL_RetArr1; STD_Array1_Val(Arr1);  // should show 'X' 'Y'
  Arr2 := CDECL_RetArr2; STD_Array2_Val(Arr2);  // should show 111 222
  Arr1 := SAFE_RetArr1; STD_Array1_Val(Arr1);  // should show 'X' 'Y'
  Arr2 := SAFE_RetArr2; STD_Array2_Val(Arr2);  // should show 111 222

  // dynamic array test
  WriteLn(CRLF+'Array test 2...');
  writeln(STD_SumIArr(4,5,6,[1,2,3,4,5]));        // 456015
  writeln(STD_SumIArr2(4,5,6,[1,2,3,4,5]));       // 456015
  writeln(REG_SumIArr(4,5,6,[1,2,3,4,5]));        // 456015
  writeln(REG_SumIArr2(4,5,6,[1,2,3,4,5]));       // 456015
  writeln(PAS_SumIArr(4,5,6,[1,2,3,4,5]));        // 456015
  writeln(PAS_SumIArr2(4,5,6,[1,2,3,4,5]));       // 456015
  writeln(CDECL_SumIArr(4,5,6,[1,2,3,4,5]));      // 456015
  writeln(CDECL_SumIArr2(4,5,6,[1,2,3,4,5]));     // 456015
  writeln(SAFE_SumIArr(4,5,6,[1,2,3,4,5]));       // 456015
  writeln(SAFE_SumIArr2(4,5,6,[1,2,3,4,5]));      // 456015

  // more dynamic array test
  WriteLn(CRLF+'Array test 3...');
  for i := 1 to 10 do Arr2[i]:=i;
  for i := 11 to 200 do Arr2[i]:=0;
  writeln(STD_SumIArr(4,5,6,Arr2));               // 456055
  writeln(STD_SumIArr2(4,5,6,Arr2));              // 456055
  writeln(REG_SumIArr(4,5,6,Arr2));               // 456055
  writeln(REG_SumIArr2(4,5,6,Arr2));              // 456055
  writeln(PAS_SumIArr(4,5,6,Arr2));               // 456055
  writeln(PAS_SumIArr2(4,5,6,Arr2));              // 456055
  writeln(CDECL_SumIArr(4,5,6,Arr2));             // 456055
  writeln(CDECL_SumIArr2(4,5,6,Arr2));            // 456055
  writeln(SAFE_SumIArr(4,5,6,Arr2));              // 456055
  writeln(SAFE_SumIArr2(4,5,6,Arr2));             // 456055

  // still dynamic array test
  WriteLn(CRLF+'Array test 4...');
  SetLength(IArr, 100); for i:= 0 to 9 do IArr[i]:=(i+1);
  writeln(STD_SumIArr(4,5,6,IArr));               // 456055
  writeln(STD_SumIArr2(4,5,6,IArr));              // 456055
  writeln(REG_SumIArr(4,5,6,IArr));               // 456055
  writeln(REG_SumIArr2(4,5,6,IArr));              // 456055
  writeln(PAS_SumIArr(4,5,6,IArr));               // 456055
  writeln(PAS_SumIArr2(4,5,6,IArr));              // 456055
  writeln(CDECL_SumIArr(4,5,6,IArr));             // 456055
  writeln(CDECL_SumIArr2(4,5,6,IArr));            // 456055
  writeln(SAFE_SumIArr(4,5,6,Arr2));              // 456055
  writeln(SAFE_SumIArr2(4,5,6,Arr2));             // 456055

  // multiple param test
  WriteLn(CRLF+'Multi-param test...');
  WriteLn(STD_MultiParam(1, 2, 3, 4, 5, 3.1415, 'qwertz', Rec, Rec2));
  WriteLn(REG_MultiParam(1, 2, 3, 4, 5, 3.1415, 'qwertz', Rec, Rec2));
  WriteLn(PAS_MultiParam(1, 2, 3, 4, 5, 3.1415, 'qwertz', Rec, Rec2));
  WriteLn(CDECL_MultiParam(1, 2, 3, 4, 5, 3.1415, 'qwertz', Rec, Rec2));
  WriteLn(SAFE_MultiParam(1, 2, 3, 4, 5, 3.1415, 'qwertz', Rec, Rec2));

  // Variant test
  WriteLn(CRLF+'Variant test...');
  V1:='Var'; V2:='iant'; V3 := '-Test';
  WriteLn('['+STD_Variant(V1, V2, V3)+']');
  WriteLn('['+REG_Variant(V1, V2, V3)+']');
  WriteLn('['+PAS_Variant(V1, V2, V3)+']');
  WriteLn('['+SAFE_Variant(V1, V2, V3)+']');
  WriteLn('['+CDECL_Variant(V1, V2, V3)+']');

  writeln(CRLF, LocalTest());
  WriteLn('Tests finished.');
end.