// Classses and Objects: 
// Properties, Assigned function.
//

program DemoCls;
uses
  Shapes;
var
  P : TPoint;
  I : Integer;
  S : TSquare;
begin
  writeln( Assigned( P ) );

  P := TPoint.Create( 3, 5 );

  writeln( Assigned( P ) );

  writeln( P ); // we can use any variable as actual parameter

  I := P.X;
  writeln( I );
  P.X := 4000;  // write property
  I := P.X;     // read property
  writeln( P.X );

  P.Free;
  writeln( Assigned( P ) );  

  S := TSquare.Create( TPoint.Create( 10, 20 ), TPoint.Create( 30, 40 ) );
  S.Show;
  S.Points[1] := TPoint.Create( 6, 7 );  // write array property
  S.Show;

  writeln;

  S.Points[1].Show; // read array property

  writeln;

  P := S.Points[2]; // read array property
  P.Show;

  writeln;

  S.Center.Show; // read read-only property

  S.Free;
end.

