// Classses and Objects: Polymorphism.
//

program DemoCls;
uses
  Shapes;
var
  I, J : Integer;
  A : array[ 1..5 ] of TShape;
  S : TSquare;
begin
  for I:=1 to 5 do
  begin
    J := Random(3);

    if J = 0 then
      A[I] := TPoint.Create( Random(100), Random(100) )
    else if J = 1 then
      A[I] := TCircle.Create( Random(100), Random(100), Random(100) )
    else if J = 2 then
      A[I] := TSquare.Create( TPoint.Create( Random(100), Random(100) ), 
                              TPoint.Create( Random(100), Random(100) ) );
    A[I].Show;
    writeln;

    if A[I] is TSquare then
    begin
      S := A[I] as TSquare;

      writeln( 'Center:' );
      writeln( S.Center );
      writeln;
    end
  end;

  for I:=1 to 5 do
    A[I].Free;

  writeln( A ); 
end.
