//
// QuickSort algorithm: an open array parameters demo program
//

program Demo;

procedure QuickSort( var A : array of Integer; L, H : Integer );
var
  I, J, X, temp : Integer;
begin
  I := L;
  J := H;
  X := A[ ( I + J ) div 2 ];
  repeat
    while A[ I ] < X do I := I + 1;
    while X < A[ J ] do J := J - 1;
    if I <= J then
    begin 
      temp := A[ I ];
      A[ I ] := A[ J ];
      A[ J ] := temp; 
      I := I + 1;
      J := J - 1;
    end;
  until I > J;
  if L < J then QuickSort( A, L, J );
  if I < H then QuickSort( A, I, H );
end;

var
  c : Char;
  A : array[ 'A'..'z' ] of Integer;
begin
  for c:='A' to 'z' do A[ c ] := Random( 500 );

  QuickSort( A, 0, Length( A ) - 1 ); 

  writeln( A ); 
end.
